SystemOrganization addCategory: #'60Deprecated-Collections-Streams'!
SystemOrganization addCategory: #'60Deprecated-Kernel-Methods'!
SystemOrganization addCategory: #'60Deprecated-NSPlugin-System-Support'!
SystemOrganization addCategory: #'60Deprecated-System-Support'!
SystemOrganization addCategory: #'60Deprecated-Tools-Inspector'!
SystemOrganization addCategory: #'60Deprecated-Tools-Menus'!

!CompiledCode methodsFor: '*60Deprecated-printing' stamp: 'mt 5/24/2018 09:27'!
printSignatureOn: aStream
	
	self deprecated: 'Use #printReferenceOn:.'.
	^ self printReferenceOn: aStream! !

!StandardFileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
isRunningAsBrowserPlugin 
	self new waitBrowserReadyFor: 1000 ifFail: [^false].
	^true! !

!StandardFileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
privateCheckForBrowserPrimitives 
	<primitive:'primitivePluginBrowserReady'>
	^false! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
defaultBrowserReadyWait 
	^5000! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
post: data target: target url: url ifError: errorBlock 
	"Post data to the given URL. The returned file stream contains the reply of the server.
	If Squeak is not running in a browser evaluate errorBlock"

	self waitBrowserReadyFor: self defaultBrowserReadyWait ifFail: [^errorBlock value].
	Smalltalk newExternalSemaphoreDo: [ :semaphore :index |
		| request result |
		request := self primURLPost: url target: target data: data semaIndex: index.
		request ifNil: [
			Smalltalk unregisterExternalObject: semaphore.
			^errorBlock value ].
		[ semaphore wait. "until something happens"
			result := self primURLRequestState: request.
			result == nil ] whileTrue.
		result ifTrue: [ fileID := self primURLRequestFileHandle: request ].
		self primURLRequestDestroy: request.
		Smalltalk unregisterExternalObject: semaphore ].
	fileID ifNil: [ ^nil ].
	self register.
	name := url.
	rwmode := false.
	buffer1 := String new: 1.
	self enableReadBuffering! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
post: data url: url ifError: errorBlock 

	self post: data target: nil url: url ifError: errorBlock! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
primBrowserReady 
	<primitive:'primitivePluginBrowserReady'>
	^nil! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
primURLPost: url data: contents semaIndex: index 
	^self primURLPost: url target: nil data: contents semaIndex: index! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
primURLPost: url target: target data: contents semaIndex: index 
	"Post the data (url might be 'mailto:' etc)"
	<primitive:'primitivePluginPostURL'>
	^nil
 ! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
primURLRequest: url semaIndex: index 
	<primitive:'primitivePluginRequestURLStream'>
	^nil! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
primURLRequest: url target: target semaIndex: index 
	"target - String (frame, also ':=top', ':=parent' etc)"
	<primitive:'primitivePluginRequestURL'>
	^nil
 ! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
primURLRequestDestroy: request 
	<primitive:'primitivePluginDestroyRequest'>
	^nil! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
primURLRequestFileHandle: request 
	<primitive: 'primitivePluginRequestFileHandle'>
	^nil! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
primURLRequestState: request 
	<primitive:'primitivePluginRequestState'>
	^false! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
requestURL: url target: target 
	^self requestURL: url target: target ifError: [nil]! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
requestURL: url target: target ifError: errorBlock 
	"Request to go to the target for the given URL.
	If Squeak is not running in a browser evaluate errorBlock"

	self waitBrowserReadyFor: self defaultBrowserReadyWait ifFail: [^errorBlock value].
	Smalltalk newExternalSemaphoreDo: [ :semaphore :index |
		| request result |
		request := self primURLRequest: url target: target semaIndex: index.
		request ifNil: [
			Smalltalk unregisterExternalObject: semaphore.
			^errorBlock value ].
		[ semaphore wait. "until something happens"
			result := self primURLRequestState: request.
			result == nil ] whileTrue.
		self primURLRequestDestroy: request.
		Smalltalk unregisterExternalObject: semaphore ].
	fileID ifNil: [ ^nil ].
	self register.
	name := url.
	rwmode := false.
	buffer1 := String new: 1.
	self enableReadBuffering! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
requestURLStream: url 
	"FileStream requestURLStream:'http://www.squeak.org'"
	^self requestURLStream: url ifError:[nil]! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
requestURLStream: url ifError: errorBlock 
	"Request a FileStream for the given URL.
	If Squeak is not running in a browser evaluate errorBlock"
	"FileStream requestURLStream:'http://www.squeak.org'"

	self waitBrowserReadyFor: self defaultBrowserReadyWait ifFail: [^errorBlock value].
	Smalltalk newExternalSemaphoreDo: [ :semaphore :index |
		| request result |
		request := self primURLRequest: url semaIndex: index.
		request ifNil: [
			Smalltalk unregisterExternalObject: semaphore.
			^errorBlock value ].
		[ semaphore wait. "until something happens"
			result := self primURLRequestState: request.
			result == nil ] whileTrue.
		result ifTrue: [ fileID := self primURLRequestFileHandle: request ].
		self primURLRequestDestroy: request.
		Smalltalk unregisterExternalObject: semaphore ].
	fileID ifNil: [ ^nil ].
	self register.
	name := url.
	rwmode := false.
	buffer1 := String new: 1.
	self enableReadBuffering! !

!StandardFileStream methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:11'!
waitBrowserReadyFor: timeout ifFail: errorBlock 
	| startTime delay okay |
	okay := self primBrowserReady.
	okay ifNil:[^errorBlock value].
	okay ifTrue: [^true].
	startTime := Time millisecondClockValue.
	delay := Delay forMilliseconds: 100.
	[(Time millisecondsSince: startTime) < timeout]
		whileTrue: [
			delay wait.
			okay := self primBrowserReady.
			okay ifNil:[^errorBlock value].
			okay ifTrue: [^true]].
	^errorBlock value! !

!HashedCollection methodsFor: '*60Deprecated-compatibility' stamp: 'ar 1/8/2010 09:02'!
findElementOrNil: anObject
	"This method has been superseeded by #scanFor:
	It is here for compatibility with external packages only."
	^self scanFor: anObject! !

!HashedCollection methodsFor: '*60Deprecated-compatibility' stamp: 'ul 1/25/2010 18:07'!
fullCheck
	"This is a private method, formerly implemented in Set, that is no longer required.
	It is here for compatibility with external packages only."
	"Keep array at least 1/4 free for decent hash behavior"
	
	array size * 3 < (tally * 4) ifTrue: [ self grow ]! !

!Utilities class methodsFor: '*60Deprecated-identification' stamp: 'mt 4/17/2018 15:49'!
setAuthorInitials: aString

	"mt: Not now (17/04/2018) for SmalltalkCI. See: https://github.com/hpi-swa/smalltalkCI/issues/368
	self deprecated: 'Use #authorInitials:.'."
	
	self authorInitials: aString.! !

!SystemVersion class methodsFor: '*60Deprecated-testing method dictionary' stamp: 'fbs 7/25/2013 07:20'!
check: pluginVersion andRequestPluginUpdate: updateURL
	"SystemVersion check: 'zzz' andRequestPluginUpdate: 'http://www.squeakland.org/installers/update.html' "

	"We don't have a decent versioning scheme yet, so we are basically checking for a nil VM version on the mac."
	(self pluginVersion: pluginVersion newerThan: self currentPluginVersion)
		ifFalse: [^true].
	(self confirm: 'There is a newer plugin version available. Do you want to install it now?')
		ifFalse: [^false].
	HTTPClient
		requestURL: updateURL , (Smalltalk platformName copyWithout: Character space) asLowercase , '.html'
		target: '_top'.
	^false! !

!ObjectExplorer methodsFor: '*60Deprecated-Tools' stamp: 'tpr 5/10/2018 14:38'!
classHierarchy
	"Create and schedule a class list browser on the receiver's hierarchy."

	self deprecated: 'Use #browseClassHierarchy instead'.
	self browseClassHierarchy
! !

!EllipseMorph methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/11/2018 08:56'!
doesBevels
	self deprecated: 'Use border styles such as InsetBorder or RaisedBorder.'.
	^ false! !

Inspector subclass: #ExternalStructureInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Tools-Inspector'!

!ExternalStructureInspector methodsFor: 'accessing' stamp: 'hg 2/28/2000 14:20'!
fieldList
	^  (Array with: 'self: ', object defaultLabelForInspector with: 'all inst vars'), self recordFieldList! !

!ExternalStructureInspector methodsFor: 'accessing' stamp: 'gk 3/1/2005 12:07'!
recordFieldList
	| fields |
	fields := object class fields.
	(fields first isKindOf: Array) ifFalse: [fields := Array with: fields].
	^fields collect: [ :field | field first ] thenSelect: [:name | name notNil]! !

!ExternalStructureInspector methodsFor: 'selecting' stamp: 'hg 2/28/2000 14:12'!
replaceSelectionValue: anObject 
	"Add colon to fieldname to get setter selector, and send it to object with the argument.
	 Refer to the comment in Inspector|replaceSelectionValue:."

	selectionIndex = 1
		ifTrue: [^object]
		ifFalse: [^object perform: ((self fieldList at: selectionIndex), ':') asSymbol with: anObject]! !

!ExternalStructureInspector methodsFor: 'selecting' stamp: 'hg 2/28/2000 14:22'!
selection 
	"Refer to the comment in Inspector|selection."
	selectionIndex = 0 ifTrue:[^object printString].
	selectionIndex = 1 ifTrue: [^object].
	selectionIndex = 2 ifTrue:[^object longPrintString].
	selectionIndex > 2
		ifTrue: [^object perform: (self fieldList at: selectionIndex)]! !

!PasteUpMorph methodsFor: '*60Deprecated-menu & halo' stamp: 'dgd 9/6/2003 17:58'!
isOpenForDragNDropString
	"Answer the string to be shown in a menu to represent the  
	open-to-drag-n-drop status"
	^ (self dragNDropEnabled
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'open to drag & drop' translated! !

!PasteUpMorph methodsFor: '*60Deprecated-accessing' stamp: 'tfel 9/23/2016 16:51'!
modalWindow: aMorph

	self deprecated: 'The global becomeModal is no longer supported, use e.g. a dialog window'.
	"(self valueOfProperty: #modalWindow)
		ifNotNil: [:morph | morph doCancel].
	self setProperty: #modalWindow toValue: aMorph.
	aMorph
		ifNotNil: [self
				when: #aboutToLeaveWorld
				send: #removeModalWindow
				to: self]"! !

!PasteUpMorph methodsFor: '*60Deprecated-accessing' stamp: 'tfel 9/23/2016 16:50'!
removeModalWindow
	self deprecated: 'The global becomeModal is no longer supported, use e.g. a dialog window'.
	"self modalWindow: nil"! !

!DummyUIManager methodsFor: '*60Deprecated' stamp: 'fbs 10/31/2013 07:41'!
fontFromUser: priorFont
	self error: 'No user response possible'! !

!DummyUIManager methodsFor: '*60Deprecated' stamp: 'tpr 1/28/2018 17:50'!
openPluggableFileList: aPluggableFileList label: aString in: aWorld
	"PluggableFileList is being deprecated and this can go away soon"
	^nil! !

!DummyUIManager methodsFor: '*60Deprecated' stamp: 'tpr 1/28/2018 17:48'!
openPluggableFileListLabel: aString in: aWorld
	"PluggableFileList is being deprecated and this can go away soon"
	^nil! !

!RunArray methodsFor: '*60Deprecated' stamp: 'nice 7/21/2011 20:36'!
addLast: value times: times
	"Add value as the last element of the receiver, the given number of times"
	self deprecated: 'use add:withOccurrences:'.
	^self add: value withOccurrences: times! !

!BorderedMorph methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/11/2018 08:56'!
doesBevels
	"To return true means that this object can show bevelled borders, and
	therefore can accept, eg, #raised or #inset as valid borderColors.
	Must be overridden by subclasses that do not support bevelled borders."

	self deprecated: 'Use border styles such as InsetBorder or RaisedBorder.'.
	^ false! !

!BorderedMorph methodsFor: '*60Deprecated-private' stamp: 'mt 11/30/2018 10:46'!
setBorderWidth: w borderColor: bc

	self deprecated: 'mt: Use #borderStyle: or #borderWidth:/Color: directly.'.
	
	self borderWidth: w.
	self borderColor: bc.! !

!BorderedMorph methodsFor: '*60Deprecated-private' stamp: 'mt 11/30/2018 10:47'!
setColor: c borderWidth: w borderColor: bc

	self deprecated: 'mt: Use #borderStyle: or #borderWidth:/Color: directly.'.
	
	self color: c.
	self borderWidth: w.
	self borderColor: bc.! !

HTTPDownloadRequest subclass: #PluginHTTPDownloadRequest
	instanceVariableNames: 'fileStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-NSPlugin-System-Support'!

!PluginHTTPDownloadRequest commentStamp: '<historical>' prior: 0!
HTTPBrowserRequest attempts to fetch the contents through a Webbrowser. This works transparently if Squeak is not running in the browser.!

!PluginHTTPDownloadRequest methodsFor: 'accessing' stamp: 'nk 8/30/2004 07:58'!
contentStream
	semaphore wait.
	fileStream
		ifNotNil: [^ fileStream].
	^ content
		ifNotNil: [content isString
				ifTrue: [self error: 'Error loading ' , self url printString]
				ifFalse: [content contentStream]]! !

!PluginHTTPDownloadRequest methodsFor: 'accessing' stamp: 'sd 1/30/2004 15:21'!
contents
	| |
	semaphore wait.
	(content isNil and:[fileStream notNil]) ifTrue:[
"		pos := fileStream position."
		fileStream position: 0.
		content := MIMEDocument content: fileStream upToEnd.
		fileStream close.
	].
	^content! !

!PluginHTTPDownloadRequest methodsFor: 'accessing' stamp: 'ar 12/21/1999 16:36'!
maxAttempts
	"Return the number of attempts to retry before giving up"
	^3! !

!PluginHTTPDownloadRequest methodsFor: 'accessing' stamp: 'sd 1/30/2004 15:21'!
signalAbort
	fileStream ifNotNil: [
		fileStream close].
	fileStream := nil.
	super signalAbort.! !

!PluginHTTPDownloadRequest methodsFor: 'accessing' stamp: 'mir 1/11/2000 11:36'!
startRetrieval
	| attempts |
	attempts := self maxAttempts.
	"Note: Only the first request may fail due to not running in a browser"
	url first = $/
		ifTrue: [url := url copyFrom: 2 to: url size].
	fileStream := FileStream requestURLStream: url ifError:[^super startRetrieval].
	[fileStream == nil] whileTrue:[
		attempts := attempts - 1.
		attempts = 0 ifTrue:[^self content:'Error downloading file'].
		fileStream := FileStream requestURLStream: url].
	semaphore signal.! !

!Set methodsFor: '*60Deprecated-adding' stamp: 'eem 6/23/2017 12:04'!
addNewElement: anObject 
	"Ensure anObject is part of the receiver.  Answer whether its membership was newly acquired."
	| index |
	self deprecated: 'Use ifAbsentAdd: instead.'.
	index := self scanFor: anObject.
	^ (array at: index)
		ifNil:
			[ self
				atNewIndex: index
				put: anObject asSetElement.
			true ]
		ifNotNil: [ false ]! !

!SystemWindow methodsFor: '*60Deprecated-open/close' stamp: 'mt 4/5/2018 09:55'!
anyOpenWindowLikeMe
	
	self deprecated: 'Use #anyOpenWindowLikeMe: passing a concrete world object.'.
	^ self anyOpenWindowLikeMeIn: Project current world! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:07'!
httpPostDocument: url args: argsDict
	| argString |
	self deprecated: 'Browser plugin based http requests are not supported anymore.'.
	argString := argsDict
		ifNotNil: [argString := HTTPSocket argString: argsDict]
		ifNil: [''].
	^self post: argString url: url , argString ifError: [self halt]! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
httpPostMultipart: url args: argsDict 
	| mimeBorder argsStream crLf resultStream result |
	" do multipart/form-data encoding rather than x-www-urlencoded "

	crLf := String crlf.
	mimeBorder := '----squeak-', Time millisecondClockValue printString, '-stuff-----'.
	"encode the arguments dictionary"
	argsStream := WriteStream on: String new.
	argsDict associationsDo: [:assoc |
		assoc value do: [ :value | | fieldValue |
		"print the boundary"
		argsStream nextPutAll: '--', mimeBorder, crLf.
		" check if it's a non-text field "
		argsStream nextPutAll: 'Content-disposition: form-data; name="', assoc key, '"'.
		(value isKindOf: MIMEDocument)
			ifFalse: [fieldValue := value]
			ifTrue: [argsStream nextPutAll: ' filename="', value url pathForFile, '"', crLf, 'Content-Type: ', value contentType.
				fieldValue := (value content
					ifNil: [(FileStream fileNamed: value url pathForFile) contentsOfEntireFile]
					ifNotNil: [value content]) asString].
" Transcript show: 'field=', key, '; value=', fieldValue; cr. "
		argsStream nextPutAll: crLf, crLf, fieldValue, crLf.
	]].
	argsStream nextPutAll: '--', mimeBorder, '--'.

	resultStream := self
		post: 
			('Content-type: multipart/form-data; boundary=', mimeBorder, crLf,
			'Content-length: ', argsStream contents size printString, crLf, crLf, 
			argsStream contents)
		url: url ifError: [^'Error in post ' url asString].
	"get the header of the reply"
	result := resultStream upToEnd.
	^MIMEDocument content: result! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
post: data target: target url: url ifError: errorBlock 
	^self concreteStream new post: data target: target url: url ifError: errorBlock! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
post: data url: url ifError: errorBlock 
	^self post: data target: nil url: url ifError: errorBlock! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
requestURL: url target: target 
	"FileStream requestURL:'http://isgwww.cs.uni-magdeburg.de/~raab' target: ':=blank' "
	^self concreteStream new requestURL: url target: target! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
requestURLStream: url 
	"FileStream requestURLStream:'http://isgwww.cs.uni-magdeburg.de/~raab'"
	^self concreteStream new requestURLStream: url! !

!FileStream class methodsFor: '*60Deprecated-NSPlugin-System-Support' stamp: 'pre 5/7/2019 14:10'!
requestURLStream: url ifError: errorBlock 
	"FileStream requestURLStream:'http://isgwww.cs.uni-magdeburg.de/~raab'"
	^self concreteStream new requestURLStream: url ifError: errorBlock! !

!Behavior methodsFor: '*60Deprecated-testing method dictionary' stamp: 'eem 3/13/2018 20:34'!
thoroughWhichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a 
	literal. Dives into the compact literal notation, making it slow but 
	thorough "

	self deprecated: 'Use whichSelectorsReferTo:thorough: instead'.
	^self whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: true! !

!Behavior methodsFor: '*60Deprecated-testing method dictionary' stamp: 'eem 3/13/2018 17:02'!
whichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a literal."

	self deprecated: 'Use whichSelectorsReferTo: instead'.
	^self whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: false! !

!Behavior methodsFor: '*60Deprecated-testing method dictionary' stamp: 'eem 3/13/2018 17:01'!
whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: thorough
	"Answer a set of selectors whose methods access the argument as a literal. If thorough is true, then dives into the compact literal notation, making it slow but thorough "

	| who |
	self deprecated: 'Use whichSelectorsReferTo:thorough: instead'.
	who := IdentitySet new.
	self selectorsAndMethodsDo: [ :selector :method |
		(((thorough
			ifFalse: [ method hasLiteral: literal ]
			ifTrue: [ method hasLiteralThorough: literal ]) or: [
				specialFlag and: [ method scanFor: specialByte ] ]) and: [
			literal isVariableBinding not or: [
				"N.B. (method indexOfLiteral: literal) < method numLiterals copes with l;ooking for
				Float bindingOf: #NaN, since (Float bindingOf: #NaN) ~= (Float bindingOf: #NaN)."
				(method indexOfLiteral: literal) ~= 0] ]) ifTrue: [
			who add: selector ] ].
	^who! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:36'!
checkBoxOffColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self checkBoxOff dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:36'!
checkBoxOnColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self checkBoxOn dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:36'!
checkBoxPressedColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self checkBoxPressed dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:36'!
fullscreenWireframeIconColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self fullscreenWireframeIcon dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:36'!
radioButtonOffColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self radioButtonOff dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:37'!
radioButtonOnColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self radioButtonOn dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:37'!
radioButtonPressedColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self radioButtonPressed dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:37'!
squeakLogoIconColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self squeakLogoIcon dyed: aColor! !

!MenuIcons class methodsFor: '*60Deprecated' stamp: 'mt 3/29/2018 14:37'!
subMenuMarkerColorized: aColor

	self deprecated: 'Use Form >> #dyed: to dye forms.'.
	^ self subMenuMarker dyed: aColor! !

!FancyMailComposition methodsFor: '*60Deprecated-ST80-Support' stamp: 'dtl 2/9/2010 22:34'!
mvcOpen
	| textView sendButton  |

	mvcWindow := StandardSystemView new
		label: 'Mister Postman';
		minimumSize: 400@250;
		model: self.

	textView := PluggableTextView
		on: self
		text: #messageText
		accept: #messageText:.
	textEditor := textView controller.

	sendButton := PluggableButtonView 
		on: self
		getState: nil
		action: #submit.
	sendButton label: 'Send'.
	sendButton borderWidth: 1.

	sendButton window: (1@1 extent: 398@38).
	mvcWindow addSubView: sendButton.

	textView window: (0@40 corner: 400@250).
	mvcWindow addSubView: textView below: sendButton.

	mvcWindow controller open.

		
! !

!FileList2 class methodsFor: '*60Deprecated-Tools' stamp: 'tpr 4/11/2018 17:01'!
projectOnlySelectionMethod: incomingEntries

	self deprecated: 'use Project class>latestProjectVersionsFromFileEntries: instead'.
	
	^Project latestProjectVersionsFromFileEntries: incomingEntries! !

!InsetBorder methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 09:04'!
colorsAtCorners

	| c c14 c23 |
	self deprecated: 'See #topLeftColor and #bottomRightColor.'.

	c := self color.
	c14 := c lighter. c23 := c darker.
	^Array with: c23 with: c14 with: c14 with: c23.! !

QEncodingMimeConverter subclass: #RFC2047MimeConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Collections-Streams'!

SelectionMenu subclass: #StandardFileMenu
	instanceVariableNames: 'canTypeFileName pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Tools-Menus'!

!StandardFileMenu commentStamp: 'tpr 1/8/2019 13:33' prior: 0!
Deprecated: please don't use this class. It provides a really unpleasant UI (after all it was based on java 'swing') that can be better done by using one of the concrete subclasses of FileAbstractSelectionDialog.

Obsoloete comment:
I represent a SelectionMenu which operates like a modal dialog for selecting files, somewhat similar to the StandardFile dialogs in MacOS and Java Swing.

Try for example, the following:

	StandardFileMenu oldFile inspect

	StandardFileMenu oldFileStream inspect

	StandardFileMenu newFile inspect

	StandardFileMenu newFileStream inspect
	
	(StandardFileMenu oldFileMenu: FileDirectory default withPattern: '*') startUpWithCaption: 'Select a file:'
	
	(StandardFileMenu oldFileMenu: (FileDirectory default) withPatternList: {'*.txt'. '*.changes'}) startUpWithCaption: 'Select a file:'
!

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'tk 2/14/2000 14:28'!
newFile

	^self newFileFrom: (FileDirectory default)! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'dgd 9/21/2003 13:17'!
newFileFrom: aDirectory

	^(self newFileMenu: aDirectory)
		startUpWithCaption: 'Select a File:' translated! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'sma 4/30/2000 10:14'!
newFileMenu: aDirectory
	Smalltalk isMorphic ifFalse: [^ PluggableFileList newFileMenu: aDirectory].
	^ super new newFileFrom: aDirectory! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'rww 9/23/2001 09:56'!
newFileMenu: aDirectory withPattern: aPattern
	Smalltalk isMorphic ifFalse: [^ PluggableFileList newFileMenu: aDirectory].
	^ super new newFileFrom: aDirectory withPattern: aPattern! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'zz 8/15/2005 18:21'!
newFileMenu: aDirectory withPatternList: aPatternList
	Smalltalk isMorphic ifFalse: [^ PluggableFileList newFileMenu: aDirectory].
	^ super new newFileFrom: aDirectory withPatternList: aPatternList! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'acg 4/15/1999 22:18'!
newFileStream

	^self newFileStreamFrom: (FileDirectory default)! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'tk 2/14/2000 14:28'!
newFileStreamFrom: aDirectory

	| sfmResult fileStream |
	sfmResult := self newFileFrom: aDirectory.
	sfmResult ifNil: [^nil].
	fileStream := sfmResult directory newFileNamed: sfmResult name.
	[fileStream isNil] whileTrue:
		[sfmResult := self newFileFrom: aDirectory.
		sfmResult ifNil: [^nil].
		fileStream := sfmResult directory newFileNamed: sfmResult name].
	^fileStream
! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'tk 2/14/2000 14:28'!
oldFile

	^self oldFileFrom: (FileDirectory default)! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'dgd 9/21/2003 13:17'!
oldFileFrom: aDirectory

	^(self oldFileMenu: aDirectory)
		startUpWithCaption: 'Select a File:' translated! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'MM 4/6/2004 22:56'!
oldFileFrom: aDirectory withPattern: aPattern
"
Select an existing file from a selection conforming to aPattern.
"
	^(self oldFileMenu: aDirectory withPattern: aPattern)
		startUpWithCaption: 'Select a File:' translated! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'sma 4/30/2000 10:15'!
oldFileMenu: aDirectory
	Smalltalk isMorphic ifFalse: [^ PluggableFileList oldFileMenu: aDirectory].
	^ super new oldFileFrom: aDirectory! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'RAA 5/25/2000 09:30'!
oldFileMenu: aDirectory withPattern: aPattern

	Smalltalk isMorphic ifFalse: [^PluggableFileList oldFileMenu: aDirectory].
	^super new oldFileFrom: aDirectory withPattern: aPattern! !

!StandardFileMenu class methodsFor: 'instance creation' stamp: 'zz 8/15/2005 17:41'!
oldFileMenu: aDirectory withPatternList: aPatternList

	Smalltalk isMorphic ifFalse: [^PluggableFileList oldFileMenu: aDirectory].
	^super new oldFileFrom: aDirectory withPatternList: aPatternList! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'acg 4/15/1999 22:17'!
oldFileStream

	^self oldFileStreamFrom: (FileDirectory default)
! !

!StandardFileMenu class methodsFor: 'standard file operations' stamp: 'tk 2/14/2000 14:27'!
oldFileStreamFrom: aDirectory

	| sfmResult fileStream |
	sfmResult := self oldFileFrom: aDirectory.
	sfmResult ifNil: [^nil].
	fileStream := sfmResult directory oldFileNamed: sfmResult name.
	[fileStream isNil] whileTrue:
		[sfmResult := self oldFileFrom: aDirectory.
		sfmResult ifNil: [^nil].
		fileStream := sfmResult directory oldFileNamed: sfmResult name].
	^fileStream
! !

!StandardFileMenu methodsFor: 'private' stamp: 'acg 4/15/1999 00:32'!
advance: anInteger containingDirectoriesFrom: aDirectory

	| theDirectory |
	theDirectory := aDirectory.
	1 to: anInteger do: [:i | theDirectory := theDirectory containingDirectory].
	^theDirectory! !

!StandardFileMenu methodsFor: 'basic control sequences' stamp: 'rbb 2/16/2005 16:59'!
confirmExistingFiles: aResult

	|choice|
	(aResult directory fileExists: aResult name) ifFalse: [^aResult].
	
	choice := (UIManager default chooseFrom: #('overwrite that file' 'choose another name'
 'cancel')
		title: aResult name, '
already exists.').

	choice = 1 ifTrue: [
		aResult directory 
			deleteFileNamed: aResult name
			ifAbsent: 
				[^self startUpWithCaption: 
'Can''t delete ', aResult name, '
Select another file'].
		^aResult].
	choice = 2 ifTrue: [^self startUpWithCaption: 'Select Another File'].
	^nil
 ! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'di 5/12/2000 10:31'!
directoryNamesString: aDirectory
"Answer a string concatenating the directory name strings in aDirectory, each string followed by a '[...]' indicator, and followed by a cr."

	^ String streamContents:
		[:s | aDirectory directoryNames do: 
				[:dn | s nextPutAll: dn withBlanksTrimmed , ' [...]'; cr]]

! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'zz 8/15/2005 17:33'!
fileNamesString: aDirectory
"Answer a string concatenating the file name strings in aDirectory, each string followed by a cr."

	^String streamContents:
		[:s | 
			aDirectory fileNames do: 
				[:fn |
					pattern do:[:each | (each match: fn) ifTrue: [
						s nextPutAll: fn withBlanksTrimmed; cr]]]]
		! !

!StandardFileMenu methodsFor: 'basic control sequences' stamp: 'rbb 3/1/2005 11:14'!
getTypedFileName: aResult

	| name |
	name := UIManager default 
		request: 'Enter a new file name' 
		initialAnswer: ''.
	name = '' ifTrue: [^self startUpWithCaption: 'Select a File:' translated].
	name := aResult directory fullNameFor: name.
	^ StandardFileMenuResult
			directory: (FileDirectory forFileName: name)
			name: (FileDirectory localNameFor: name)
! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'zz 8/15/2005 16:28'!
makeFileMenuFor: aDirectory
"Initialize an instance of me to operate on aDirectory"

	| theMenu |
	pattern ifNil: [pattern := {'*'}].
	Cursor wait showWhile: 
		[self 
			labels: 	(self menuLabelsString: aDirectory)
			font: 	(MenuStyle fontAt: 1) 
			lines: 	(self menuLinesArray: aDirectory).
		theMenu := self selections: (self menuSelectionsArray: aDirectory)].
	^theMenu! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'acg 4/15/1999 21:57'!
menuLabelsString: aDirectory
"Answer a menu labels object corresponding to aDirectory"

	^ String streamContents: 
		[:s | 
			canTypeFileName ifTrue: 
				[s nextPutAll: 'Enter File Name...'; cr].
			s nextPutAll: (self pathPartsString: aDirectory).
			s nextPutAll: (self directoryNamesString: aDirectory).
			s nextPutAll: (self fileNamesString: aDirectory).
			s skip: -1]! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'tpr 11/28/2003 15:12'!
menuLinesArray: aDirectory
"Answer a menu lines object corresponding to aDirectory"

	| typeCount nameCnt dirDepth|
	typeCount := canTypeFileName 
		ifTrue: [1] 
		ifFalse: [0].
	nameCnt := aDirectory directoryNames size.
	dirDepth := aDirectory pathParts size.
	^Array streamContents: [:s |
		canTypeFileName ifTrue: [s nextPut: 1].
		s nextPut: dirDepth + typeCount + 1.
		s nextPut: dirDepth + nameCnt + typeCount + 1]! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'zz 8/15/2005 18:18'!
menuSelectionsArray: aDirectory
"Answer a menu selections object corresponding to aDirectory.  The object is an array corresponding to each item, each element itself constituting a two-element array, the first element of which contains a selector to operate on and the second element of which contains the parameters for that selector."

	|dirSize|
	dirSize := aDirectory pathParts size.
	^Array streamContents: [:s |
		canTypeFileName ifTrue:
			[s nextPut: (StandardFileMenuResult
				directory: aDirectory
				name: nil)].
		s nextPut: (StandardFileMenuResult
			directory: (FileDirectory root)
			name: '').
		aDirectory pathParts doWithIndex: 
			[:d :i | s nextPut: (StandardFileMenuResult
					directory: (self 
						advance: dirSize - i
						containingDirectoriesFrom: aDirectory)
					name: '')].
		aDirectory directoryNames do: 
			[:dn |  s nextPut: (StandardFileMenuResult
						directory: (FileDirectory on: (aDirectory fullNameFor: dn))
						name: '')].
		aDirectory fileNames do: 
			[:fn | pattern do: [:pat | (pat match: fn) ifTrue: [
					s nextPut: (StandardFileMenuResult
						directory: aDirectory
						name: fn)]]]]! !

!StandardFileMenu methodsFor: 'private' stamp: 'acg 4/15/1999 22:03'!
newFileFrom: aDirectory

	canTypeFileName := true.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 16:29'!
newFileFrom: aDirectory withPattern: aPattern

	canTypeFileName := true.
	pattern := {aPattern}.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 18:25'!
newFileFrom: aDirectory withPatternList: aPatternList

	canTypeFileName := true.
	pattern := aPatternList.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'private' stamp: 'acg 4/15/1999 22:03'!
oldFileFrom: aDirectory

	canTypeFileName := false.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 16:28'!
oldFileFrom: aDirectory withPattern: aPattern

	canTypeFileName := false.
	pattern := {aPattern}.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 17:28'!
oldFileFrom: aDirectory withPatternList: aPatternList

	canTypeFileName := false.
	pattern := aPatternList.
	^self makeFileMenuFor: aDirectory! !

!StandardFileMenu methodsFor: 'menu building' stamp: 'acg 4/15/1999 21:03'!
pathPartsString: aDirectory
"Answer a string concatenating the path parts strings in aDirectory, each string followed by a cr."

	^String streamContents:
		[:s | 
			s nextPutAll: '[]'; cr.
			aDirectory pathParts asArray doWithIndex: 
				[:part :i |
					s next: i put: $ .
					s nextPutAll: part withBlanksTrimmed; cr]]! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 16:31'!
pattern: aPattern
	" * for all files, or '*.cs' for changeSets, etc.  Just like fileLists"

	pattern := {aPattern}! !

!StandardFileMenu methodsFor: 'private' stamp: 'zz 8/15/2005 17:29'!
patternList: aPatternList

	pattern := aPatternList! !

!StandardFileMenu methodsFor: 'basic control sequences' stamp: 'acg 9/28/1999 23:34'!
startUpWithCaption: aString at: location

	|result|
	result := super startUpWithCaption: aString at: location.
	result ifNil: [^nil].
	result isDirectory ifTrue:
		[self makeFileMenuFor: result directory.
		 self computeForm.
		 ^self startUpWithCaption: aString at: location].
	result isCommand ifTrue: 
		[result := self getTypedFileName: result.
		result ifNil: [^nil]].
	canTypeFileName ifTrue: [^self confirmExistingFiles: result].
	^result
	! !

!RaisedBorder methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 09:04'!
colorsAtCorners

	| c c14 c23 |
	self deprecated: 'See #topLeftColor and #bottomRightColor.'.
	c := self color.
	c14 := c lighter. c23 := c darker.
	^Array with: c14 with: c23 with: c23 with: c14! !

!UndefinedObject methodsFor: '*60Deprecated' stamp: ''!
suspend
	"Kills off processes that didn't terminate properly"
	"Display reverse; reverse."  "<-- So we can catch the suspend bug"
	Processor terminateActive! !

!AutoStart class methodsFor: '*60Deprecated' stamp: 'mt 8/14/2016 09:55'!
checkForPluginUpdate
	| pluginVersion updateURL |
	HTTPClient isRunningInBrowser
		ifFalse: [^false].
	pluginVersion := Smalltalk namedArguments
		at: (Smalltalk platformName copyWithout: Character space) asUppercase
		ifAbsent: [^false].
	updateURL := Smalltalk namedArguments
		at: 'UPDATE_URL'
		ifAbsent: [^false].
	^SystemVersion check: pluginVersion andRequestPluginUpdate: updateURL! !

!AutoStart class methodsFor: '*60Deprecated' stamp: 'mt 8/14/2016 09:55'!
checkForUpdates
	| availableUpdate updateServer |
	HTTPClient isRunningInBrowser ifFalse: [ ^ self processUpdates ].
	availableUpdate := (Smalltalk namedArguments
		at: 'UPDATE'
		ifAbsent: [ '' ]) asInteger.
	availableUpdate ifNil: [ ^ false ].
	updateServer := Smalltalk namedArguments
		at: 'UPDATESERVER'
		ifAbsent:
			[ Smalltalk namedArguments
				at: 'UPDATE_SERVER'
				ifAbsent: [ 'Squeakland' ] ].
	UpdateStreamDownloader default setUpdateServer: updateServer.
	^ SystemVersion checkAndApplyUpdates: availableUpdate! !

!Context methodsFor: '*60Deprecated-controlling' stamp: 'eem 6/14/2008 19:17'!
blockCopy: numArgs 
	"Primitive. Distinguish a block of code from its enclosing method by 
	creating a new BlockContext for that block. The compiler inserts into all 
	methods that contain blocks the bytecodes to send the message 
	blockCopy:. Do not use blockCopy: in code that you write!! Only the 
	compiler can decide to send the message blockCopy:. Fail if numArgs is 
	not a SmallInteger. Optional. No Lookup. See Object documentation 
	whatIsAPrimitive."

	<primitive: 80>
	^ (BlockContext newForMethod: self method)
		home: self home
		startpc: pc + 2
		nargs: numArgs! !

Context variableSubclass: #ContextPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Kernel-Methods'!

ContextPart variableSubclass: #BlockContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Kernel-Methods'!

ContextPart variableSubclass: #MethodContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Kernel-Methods'!

!ComplexBorder methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 09:03'!
widthForRounding

	self deprecated: 'See BalloonCanvas for drawing rounded corners.'.
	^0! !

!StandardToolSet class methodsFor: '*60Deprecated-inspecting' stamp: 'mt 2/6/2018 10:15'!
inspectorClassOf: anObject
	
	self deprecated: 'Use #inspectorClass.'.
	^ anObject inspectorClass! !

!Character class methodsFor: '*60Deprecated-constants' stamp: 'ul 5/4/2018 21:31'!
characterTable
	"Answer the class variable in which unique Characters are stored."

	self deprecated: 'All characters are immediate.'.
	^self allByteCharacters as: String! !

!TTSampleFontMorph methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/11/2018 08:57'!
doesBevels
	self deprecated: 'Use border styles such as InsetBorder or RaisedBorder.'.
	^ false! !

!Morph methodsFor: '*60Deprecated-user-interface' stamp: 'tfel 9/23/2016 16:50'!
becomeModal
	
	self deprecated: 'The global becomeModal is no longer supported, use e.g. a dialog window'.
	"self currentWorld
		ifNotNil: [self currentWorld modalWindow: self]"! !

!Morph methodsFor: '*60Deprecated-meta-actions' stamp: 'mt 6/29/2017 17:12'!
blueButtonDown: anEvent
	"Nothing."
	
	self deprecated: 'Use #mouseDown:.'.! !

!Morph methodsFor: '*60Deprecated-meta-actions' stamp: 'mt 6/29/2017 17:12'!
blueButtonUp: anEvent
	"Ignored. Theoretically we should never get here since control is transferred to the halo on #blueButtonDown: but subclasses may implement this differently."
	
	self deprecated: 'Use #mouseUp:.'.! !

!Morph methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/11/2018 08:57'!
doesBevels
	"To return true means that this object can show bevelled borders, and
	therefore can accept, eg, #raised or #inset as valid borderColors.
	Must be overridden by subclasses that do not support bevelled borders."

	self deprecated: 'Use border styles such as InsetBorder or RaisedBorder.'.
	^ false! !

!Morph methodsFor: '*60Deprecated-meta-actions' stamp: 'mt 6/29/2017 17:09'!
handlerForBlueButtonDown: anEvent
	
	self deprecated: 'Use #handlerForMouseDown:.'.
	^ nil! !

!Morph methodsFor: '*60Deprecated-meta-actions' stamp: 'mt 6/30/2017 09:12'!
handlerForMetaMenu: evt
	
	self deprecated: 'Use #handlerForMouseDown: or #wantsMetaMenu or #mouseDownPriority.'.
	^ nil! !

!Morph methodsFor: '*60Deprecated-MorphicExtras-accessing' stamp: 'pre 6/8/2018 16:47'!
highlightOnlySubmorph: aMorph
	"Distinguish only aMorph with border highlighting (2-pixel wide red); make all my other submorphs have one-pixel-black highlighting.  This is a rather special-purpose and hard-coded highlighting regime, of course.  Later, if someone cared to do it, we could parameterize the widths and colors via properties, or some such."

	self deprecated: 'Do not use at all anymore. This was a specialized call for the objects tool which does not work in a general way on arbitrary morphs.'.
	self submorphs do:
		[:m |
			m == aMorph
				ifTrue: [m borderWidth: 1; borderColor: Color red. m firstSubmorph color: Color red]
				ifFalse: [m borderWidth: 1; borderColor: Color black. m firstSubmorph color: Color black]].
! !

!Morph methodsFor: '*60Deprecated-dropping/grabbing' stamp: 'pre 11/1/2018 15:40'!
toggleDragNDrop
	"Toggle this morph's ability to add and remove morphs via drag-n-drop."

	self enableDragNDrop: self dragNDropEnabled not.
! !

!SmalltalkImage methodsFor: '*60Deprecated-special objects' stamp: 'eem 3/13/2018 17:04'!
hasSpecialSelector: aLiteral ifTrueSetByte: aBlock

	self deprecated: 'Use BytecodeEncoder class>>scanBlockOrNilForLiteral:'.
	1 to: self specialSelectorSize do:
		[:index | 
		(self specialSelectorAt: index) == aLiteral
			ifTrue: [aBlock value: index + 16rAF. ^true]].
	^false! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuBorderColor

	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #borderColor for: #MenuMorph) ifNil: [(Color r: 0.2 g: 0.3 b: 0.9)]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuBorderWidth

	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #borderWidth for: #MenuMorph) ifNil: [2]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuColor
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #color for: #MenuMorph) ifNil: [(Color r: 0.9 g: 0.9 b: 0.9)]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuLineColor
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #lineColor for: #MenuMorph) ifNil: [(Color r: 0.6 g: 0.7 b: 1)]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:20'!
menuSelectionColor
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #selectionColor for: #MenuItemMorph) ifNil: [(Color r: 0.4 g: 0.5 b: 0.7)]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuTitleBorderColor
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #titleBorderColor for: #MenuMorph) ifNil: [(Color r: 0.6 g: 0.7 b: 1)]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuTitleBorderWidth
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #titleBorderWidth for: #MenuMorph) ifNil: [0]! !

!Preferences class methodsFor: '*60Deprecated-menu colors' stamp: 'mt 8/24/2016 09:21'!
menuTitleColor
	
	self deprecated: 'mt: Use UI themes.'.
	^ (UserInterfaceTheme current get: #titleColor for: #MenuMorph) ifNil: [ Color transparent]! !

!BorderStyle methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 08:58'!
colorsAtCorners

	self deprecated: 'See #topLeftColor and #bottomRightColor.'.
	^Array new: 4 withAll: self color! !

!BorderStyle methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 09:01'!
dotOfSize: diameter forDirection: aDirection

	self deprecated: 'See Form for such convenience functions.'.
	^ Form dotOfSize: diameter color: self color! !

!BorderStyle methodsFor: '*60Deprecated-accessing' stamp: 'mt 4/23/2018 09:02'!
widthForRounding

	self deprecated: 'See BalloonCanvas for drawing rounded corners.'.
	^self width! !

!ToolSet class methodsFor: '*60Deprecated-inspecting' stamp: 'mt 2/6/2018 10:15'!
inspectorClassOf: anObject

	self deprecated: 'Use #inspectorClass.'.
	^ anObject inspectorClass! !

!String methodsFor: '*60Deprecated-user interface' stamp: 'mt 1/25/2018 08:11'!
openInWorkspaceWithTitle: aTitle
	"Open up a workspace with the receiver as its contents, with the given title"
	
	self deprecated: 'Use UIManager >> #edit:label:.'.
	UIManager default edit: self label: aTitle.! !

Object subclass: #ColorTheme
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: '60Deprecated-System-Support'!

!ColorTheme class methodsFor: 'applying' stamp: 'dgd 3/31/2006 12:25'!
apply
	^self new apply! !

!ColorTheme class methodsFor: 'applying' stamp: 'dgd 3/12/2006 13:08'!
applyTheme: aThemeClass 
	aThemeClass new apply! !

!ColorTheme class methodsFor: 'accessing' stamp: 'dgd 3/31/2006 12:07'!
current
	^ Current
		ifNil: [self defaultTheme apply]! !

!ColorTheme class methodsFor: 'accessing' stamp: 'dgd 11/2/2004 17:52'!
current: aColorTheme
	Current := aColorTheme! !

!ColorTheme class methodsFor: 'accessing' stamp: 'fbs 7/12/2013 09:21'!
defaultTheme
	^ self new.! !

!ColorTheme methodsFor: 'applying' stamp: 'mt 1/13/2016 08:18'!
apply
	"apply the receiver as the current theme"
	BalloonMorph balloonColor: self balloonColor.

	Preferences setParameter: #defaultWorldColor to: self defaultWorldColor.

	Preferences insertionPointColor: self insertionPointColor.
	Preferences keyboardFocusColor: self keyboardFocusColor.
	Preferences textHighlightColor: self textHighlightColor.

	Preferences setParameter: #menuTitleColor to: self menuTitleColor.
	Preferences setParameter: #menuTitleBorderColor to: self menuTitleBorderColor.
	Preferences setParameter: #menuTitleBorderWidth to: self menuTitleBorderWidth.
	Preferences setParameter: #menuColor to: self menuColor.
	Preferences setParameter: #menuBorderColor to: self menuBorderColor.
	Preferences setParameter: #menuLineColor to: self menuLineColor.
	Preferences setParameter: #menuBorderWidth to: self menuBorderWidth.
	Preferences setParameter: #menuSelectionColor to: self menuSelectionColor.

	SystemProgressMorph reset.

	self class current: self.
! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:33'!
balloonColor
	^ TranslucentColor
			r: 0.92
			g: 0.92
			b: 0.706
			alpha: 0.75! !

!ColorTheme methodsFor: 'theme' stamp: 'dgd 11/2/2004 21:23'!
cancelColor
	^ Color lightRed! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:34'!
defaultWorldColor
	^ Color blue muchLighter! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/3/2004 19:27'!
dialog3DTitles
	^ true! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 19:56'!
dialogBorderColor
	^ Color fromArray: #(0.355 0.516 1.0 )! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 19:54'!
dialogBorderWidth
	^ 4! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 19:59'!
dialogButtonBorderWidth
	^ 0! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 21:09'!
dialogColor
	^ Color paleYellow! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/3/2004 19:49'!
dialogPaneBorderColor
	^ Color black
! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/3/2004 19:44'!
dialogPaneBorderWidth
	^ 0! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/3/2004 19:30'!
dialogPaneRampOrColor
	^ {0.0 -> (Color r: 0.742 g: 0.871 b: 1.0).
		1.0 -> (Color r: 0.516 g: 0.645 b: 1.0)}! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/3/2004 19:38'!
dialogRampOrColor
	^ {0.0 -> (Color r: 0.516 g: 0.645 b: 1.0).
		1.0 -> (Color r: 0.742 g: 0.871 b: 1.0)}! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 21:18'!
dialogTextBoxBorderColor
	^ Color black! !

!ColorTheme methodsFor: 'theme - dialogs' stamp: 'dgd 11/2/2004 21:18'!
dialogTextBoxColor
	^ Color white! !

!ColorTheme methodsFor: 'theme' stamp: 'MAD 3/14/2010 14:58'!
disabledColor
	^ Color lightGray! !

!ColorTheme methodsFor: 'theme - dockingbar' stamp: 'fbs 7/6/2013 15:34'!
dockingBarAutoGradient
	^ true! !

!ColorTheme methodsFor: 'theme - dockingbar' stamp: 'fbs 7/6/2013 15:34'!
dockingBarColor
	^ Color r: 0.6 g: 0.7 b: 1! !

!ColorTheme methodsFor: 'theme - dockingbar' stamp: 'fbs 7/6/2013 15:35'!
dockingBarGradientRamp
	^ { 0.0 -> Color white.
		1.0 -> (Color r: 0.6 g: 0.7 b: 1) }! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:35'!
helpColor
	^ Color lightGreen! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:35'!
insertionPointColor
	^ Color red! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:35'!
keyboardFocusColor
	^ Color r: 0.6 g: 1 b: 1! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:36'!
menuBorderColor
	^ Color r: 0.2 g: 0.3 b: 0.9! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:36'!
menuBorderWidth
	^ 2! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:36'!
menuColor
	^ Color r: 0.85 g: 0.9 b: 1! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:36'!
menuLineColor
	^ Color r: 0.6 g: 0.7 b: 1! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:37'!
menuSelectionColor
	^ Color r: 0.2 g: 0.3 b: 0.9! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:37'!
menuTitleBorderColor
	^ Color r: 0.6 g: 0.7 b: 1! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:37'!
menuTitleBorderWidth
	^ 6! !

!ColorTheme methodsFor: 'theme - menus' stamp: 'fbs 7/6/2013 15:37'!
menuTitleColor
	^ Color r: 0.6 g: 0.7 b: 1! !

!ColorTheme methodsFor: 'theme' stamp: 'dgd 11/2/2004 21:22'!
okColor
	^ Color lightGreen! !

!ColorTheme methodsFor: 'theme' stamp: 'fbs 7/6/2013 15:37'!
textHighlightColor
	^ Color blue muchLighter alpha: 0.7! !

Object subclass: #HTTPClient
	instanceVariableNames: ''
	classVariableNames: 'BrowserSupportsAPI RunningInBrowser'
	poolDictionaries: ''
	category: '60Deprecated-System-Support'!

!HTTPClient class methodsFor: 'class initialization' stamp: 'mir 4/2/2002 15:37'!
browserSupportsAPI
	^BrowserSupportsAPI == true! !

!HTTPClient class methodsFor: 'class initialization' stamp: 'mir 4/2/2002 15:36'!
browserSupportsAPI: aBoolean
	BrowserSupportsAPI := aBoolean! !

!HTTPClient class methodsFor: 'utilities' stamp: 'mir 8/22/2001 12:29'!
composeMailTo: address subject: subject body: body
	"HTTPClient composeMailTo: 'michael.rueger@squeakland.org' subject: 'test subject' body: 'message' "
	| mailTo |
	mailTo := WriteStream on: String new.
	mailTo nextPutAll: 'mailto:'.
	mailTo
		nextPutAll: address;
		nextPut: $?.
	subject isEmptyOrNil
		ifFalse: [mailTo nextPutAll: 'subject='; nextPutAll: subject; nextPut: $&].
	body isEmptyOrNil
		ifFalse: [mailTo nextPutAll: 'body='; nextPutAll: body].

	self httpGet: mailTo contents! !

!HTTPClient class methodsFor: 'class initialization' stamp: 'mir 2/2/2001 17:27'!
determineIfRunningInBrowser
	"HTTPClient determineIfRunningInBrowser"

	RunningInBrowser := StandardFileStream isRunningAsBrowserPlugin
! !

!HTTPClient class methodsFor: 'examples' stamp: 'mir 2/2/2001 17:43'!
exampleMailTo
	"HTTPClient exampleMailTo"

	HTTPClient mailTo: 'm.rueger@acm.org' message: 'A test message from within Squeak'
! !

!HTTPClient class methodsFor: 'examples' stamp: 'ul 1/11/2010 07:17'!
examplePostArgs
	"HTTPClient examplePostArgs"

	| args result |
	args := Dictionary new
		at: 'arg1' put: #('val1');
		at: 'arg2' put: #('val2');
		yourself.
	result := HTTPClient httpPostDocument: 'http://www.squeaklet.com/cgi-bin/thrd.pl [^]' args: args.
	Transcript show: result content; cr; cr.

! !

!HTTPClient class methodsFor: 'examples' stamp: 'ul 1/11/2010 07:17'!
examplePostMultipart
	"HTTPClient examplePostMultipart"

	| args result |
	args := Dictionary new
		at: 'arg1' put: #('val1');
		at: 'arg2' put: #('val2');
		yourself.
	result := HTTPClient httpPostMultipart: 'http://www.squeaklet.com/cgi-bin/thrd.pl'  args: args.
	Transcript show: result content; cr; cr.

! !

!HTTPClient class methodsFor: 'utilities' stamp: 'mir 5/13/2003 10:43'!
getDirectoryListing: dirListURL
	"HTTPClient getDirectoryListing: 'http://www.squeakalpha.org/uploads' "
	| answer ftpEntries |
"	answer := self 
		httpPostDocument: dirListURL
		args: Dictionary new."
	"Workaround for Mac IE problem"
	answer := self httpGetDocument: dirListURL.
	answer isString
		ifTrue: [^self error: 'Listing failed: ' , answer]
		ifFalse: [answer := answer content].
	answer first == $<
		ifTrue: [self error: 'Listing failed: ' , answer].
	ftpEntries := answer findTokens: String crlf.
	^ ftpEntries 
		collect:[:ftpEntry | ServerDirectory parseFTPEntry: ftpEntry]
		thenSelect: [:entry | entry notNil]! !

!HTTPClient class methodsFor: 'post/get' stamp: 'nk 8/30/2004 07:50'!
httpGet: url
	| document |
	document := self httpGetDocument: url.
	^(document isString)
		ifTrue: [
			"strings indicate errors"
			document]
		ifFalse: [(RWBinaryOrTextStream with: document content) reset]! !

!HTTPClient class methodsFor: 'post/get' stamp: 'mir 5/11/2001 12:55'!
httpGetDocument: url
	| stream content | 
	^self shouldUsePluginAPI
		ifTrue: [
			stream := FileStream requestURLStream: url ifError: [self error: 'Error in get from ' , url printString].
			stream ifNil: [^''].
			stream position: 0.
			content := stream upToEnd.
			stream close.
			MIMEDocument content: content]
		ifFalse: [HTTPSocket httpGetDocument: url]! !

!HTTPClient class methodsFor: 'post/get' stamp: 'mir 5/1/2001 15:04'!
httpPostDocument: url args: argsDict
	^self httpPostDocument: url target: nil args: argsDict! !

!HTTPClient class methodsFor: 'post/get' stamp: 'mir 5/1/2001 15:06'!
httpPostDocument: url target: target args: argsDict
	| argString stream content |
	^self shouldUsePluginAPI
		ifTrue: [
			argString := argsDict
				ifNotNil: [argString := HTTPSocket argString: argsDict]
				ifNil: [''].
			stream := FileStream post: argString , ' ' target: target url: url , argString ifError: [self error: 'Error in post to ' , url printString].
			stream position: 0.
			content := stream upToEnd.
			stream close.
			MIMEDocument content: content]
		ifFalse: [HTTPSocket httpPostDocument: url  args: argsDict]! !

!HTTPClient class methodsFor: 'post/get' stamp: 'mir 5/1/2001 12:51'!
httpPostMultipart: url args: argsDict
	" do multipart/form-data encoding rather than x-www-urlencoded "

	^self shouldUsePluginAPI
		ifTrue: [self pluginHttpPostMultipart: url args: argsDict]
		ifFalse: [HTTPSocket httpPostMultipart: url args: argsDict accept: nil request: '']! !

!HTTPClient class methodsFor: 'testing' stamp: 'ccn 3/14/2001 19:56'!
isRunningInBrowser

	RunningInBrowser isNil
		ifTrue: [self determineIfRunningInBrowser].
	^RunningInBrowser! !

!HTTPClient class methodsFor: 'testing' stamp: 'mir 8/4/2003 13:44'!
isRunningInBrowser: aBoolean
	"Override the automatic process.
	This should be used with caution.
	One way to determine it without using the primitive is to check for parameters typically only encountered when running as a plugin."

	RunningInBrowser := aBoolean! !

!HTTPClient class methodsFor: 'utilities' stamp: 'mir 5/1/2001 12:51'!
mailTo: address message: aString
	HTTPClient shouldUsePluginAPI
		ifFalse: [^self error: 'You need to run inside a web browser.'].
	FileStream post: aString url: 'mailto:' , address ifError: [self error: 'Can not send mail']! !

!HTTPClient class methodsFor: 'private' stamp: 'nice 12/27/2009 03:11'!
pluginHttpPostMultipart: url args: argsDict
	| mimeBorder argsStream crLf resultStream result |
	" do multipart/form-data encoding rather than x-www-urlencoded "

	crLf := String crlf.
	mimeBorder := '----squeak-', Time millisecondClockValue printString, '-stuff-----'.
	"encode the arguments dictionary"
	argsStream := WriteStream on: String new.
	argsDict associationsDo: [:assoc |
		assoc value do: [ :value | | fieldValue |
		"print the boundary"
		argsStream nextPutAll: '--', mimeBorder, crLf.
		" check if it's a non-text field "
		argsStream nextPutAll: 'Content-disposition: form-data; name="', assoc key, '"'.
		(value isKindOf: MIMEDocument)
			ifFalse: [fieldValue := value]
			ifTrue: [argsStream nextPutAll: ' filename="', value url pathForFile, '"', crLf, 'Content-Type: ', value contentType.
				fieldValue := (value content
					ifNil: [(FileStream fileNamed: value url pathForFile) contentsOfEntireFile]
					ifNotNil: [value content]) asString].
" Transcript show: 'field=', key, '; value=', fieldValue; cr. "
		argsStream nextPutAll: crLf, crLf, fieldValue, crLf.
	]].
	argsStream nextPutAll: '--', mimeBorder, '--'.
	resultStream := FileStream
		post: 
			('ACCEPT: text/html', crLf,
			'User-Agent: Squeak 3.1', crLf,
			'Content-type: multipart/form-data; boundary=', mimeBorder, crLf,
			'Content-length: ', argsStream contents size printString, crLf, crLf, 
			argsStream contents)
		url: url ifError: [^'Error in post ' url asString].
	"get the header of the reply"
	result := resultStream
		ifNil: ['']
		ifNotNil: [resultStream upToEnd].
	^MIMEDocument content: result! !

!HTTPClient class methodsFor: 'post/get' stamp: 'mir 4/2/2002 15:52'!
requestURL: url target: target
	^self shouldUsePluginAPI
		ifTrue: [FileStream requestURL: url target: target]
		ifFalse: [self error: 'Requesting a new URL target is not supported.']! !

!HTTPClient class methodsFor: 'testing' stamp: 'mt 5/6/2016 15:21'!
shouldUsePluginAPI
	"HTTPClient shouldUsePluginAPI" 

	self isRunningInBrowser
		ifFalse: [^false].
	self browserSupportsAPI
		ifFalse: [^false].
	"The Mac plugin calls do not work in full screen mode"
	^((Smalltalk platformName = 'Mac OS')
		and: [DisplayScreen displayIsFullScreen]) not! !

!HTTPClient class methodsFor: 'utilities' stamp: 'mir 2/2/2001 17:59'!
uploadFileNamed: aFilename to: baseUrl user: user passwd: passwd

	| fileContents remoteFilename |
	remoteFilename := (baseUrl endsWith: '/')
		ifTrue: [baseUrl , '/' , aFilename]
		ifFalse: [baseUrl , aFilename].
	fileContents := (StandardFileStream readOnlyFileNamed: aFilename) contentsOfEntireFile.
	HTTPSocket httpPut: fileContents to: remoteFilename user: user passwd: passwd! !

!Object methodsFor: '*60Deprecated-copying' stamp: 'ul 4/25/2017 18:36'!
clone
	"Answer a shallow copy of the receiver."

	self deprecated: 'Use #shallowCopy'.
	^self shallowCopy! !

!Object methodsFor: '*60Deprecated-Tools' stamp: 'mt 4/5/2018 10:14'!
exploreAndYourself
	
	self deprecated: 'Use #explore because it does not return the tool window anymore. Only calls via ToolSet do so.'.
	self explore! !

Object subclass: #StandardFileMenuResult
	instanceVariableNames: 'directory name'
	classVariableNames: ''
	poolDictionaries: ''
	category: '60Deprecated-Tools-Menus'!

!StandardFileMenuResult commentStamp: 'tpr 1/8/2019 13:34' prior: 0!
Deprecated: please don't use this class any more. It is part of the deprecated StandardFileMenu system.

A StandardFileMenuResult is xxxxxxxxx.

Instance Variables
	directory:		<Object>
	name:		<Object>

directory
	- xxxxx

name
	- xxxxx
!

!StandardFileMenuResult class methodsFor: 'instance creation' stamp: 'acg 4/15/1999 08:42'!
directory: aDirectory name: aString

	^super new directory: aDirectory name: aString! !

!StandardFileMenuResult methodsFor: 'accessing' stamp: 'acg 4/15/1999 08:43'!
directory

	^directory! !

!StandardFileMenuResult methodsFor: 'accessing' stamp: 'acg 4/15/1999 08:43'!
directory: aDirectory

	^directory := aDirectory! !

!StandardFileMenuResult methodsFor: 'private' stamp: 'acg 4/15/1999 08:42'!
directory: aDirectory name: aString

	directory := aDirectory.
	name := aString.
	^self! !

!StandardFileMenuResult methodsFor: 'testing' stamp: 'acg 4/15/1999 09:05'!
isCommand

	^name isNil! !

!StandardFileMenuResult methodsFor: 'testing' stamp: 'acg 4/15/1999 20:57'!
isDirectory

	^name = ''! !

!StandardFileMenuResult methodsFor: 'accessing' stamp: 'acg 4/15/1999 08:43'!
name

	^name! !

!StandardFileMenuResult methodsFor: 'accessing' stamp: 'acg 4/15/1999 08:43'!
name: aString

	^name := aString! !

!StandardFileMenuResult methodsFor: 'accessing' stamp: 'sw 6/9/1999 11:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' with directory: '.
	directory printOn: aStream.
	aStream nextPutAll: ' name: '.
	name printOn: aStream

"StandardFileMenu oldFile"! !

!DirectoryEntry class methodsFor: '*60Deprecated-Files-Directories' stamp: 'cmm 2/15/2010 15:22'!
name: name0  creationTime: creationTime  modificationTime: modificationTime   isDirectory: isDirectory  fileSize: fileSize
	"This is the legacy creation method we are trying to phase out.  Please use #directory:  name:  creationTime:  modificationTime:  fileSize:." 
	| type |
	type := isDirectory 
		ifTrue: [ DirectoryEntryDirectory ]
		ifFalse: [ DirectoryEntryFile ].
	^ type
		directory: nil
		name: name0  
		creationTime: creationTime  
		modificationTime: modificationTime   
		fileSize: fileSize! !
